version: '3'
services:
  ###> OPENAPI ###
  swagger-editor:
    image: swaggerapi/swagger-editor
    ports:
      - "19000:8080"
    networks:
      - book-list
  swagger-ui:
    image: swaggerapi/swagger-ui
    volumes:
      - ./public/v1:/swagger
    environment:
      SWAGGER_JSON: /swagger/openapi.json
    ports:
      - "19010:8080"
    networks:
      - book-list
  ###< OPENAPI  ###

  ###> POSTGRES ###
  book-list-db:
    image: postgres:14-alpine
    ports:
      - "5432:5432"
    volumes:
      - 'book-list-db-data:/var/lib/postgresql/data'
    environment:
      - POSTGRES_PASSWORD=2vQU45haQCnDS8sO
      - POSTGRES_USER=book-list
      - POSTGRES_DB=book-list
    networks:
      - book-list
  ###< POSTGRES ###
  ###< REDIS ###
  book-list-cache:
    image: redis:7-alpine
    restart: always
    ports:
      - '6379:6379'
    command: redis-server --requirepass devRedisPassword --maxmemory 512mb --maxmemory-policy allkeys-lru
    volumes:
      - book-list-cache-data:/data
    networks:
      - book-list
  ###< REDIS ###
networks:
  book-list:
    driver: bridge
volumes:
  data-volume:
  book-list-db-data:
    driver: local
  book-list-cache-data:
    driver: local